Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 436398 - net-analyzer/netperf - add USE=sctp
Summary: net-analyzer/netperf - add USE=sctp
Status: VERIFIED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Low enhancement (vote)
Assignee: Netmon Herd
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-09-27 10:08 UTC by K. Sanborn
Modified: 2012-09-29 09:08 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description K. Sanborn 2012-09-27 10:08:36 UTC
During some testing of SCTP, I found that my build of "netperf" did not include
SCTP support. Checking, the package supports SCTP if I build it manually from the
normal distfile. Adding a "sctp" USE flag would be appropriate. Only the latest
stable version needs to be enhanced, (and any later versions...).

Reproducible: Always

Steps to Reproduce:
1. emerge -vp netperf
2. sudo netserver -p 9000
3. netperf -p 9000 -H 127.0.0.1 -t SCTP_STREAM

Actual Results:  
Got error message that SCTP_STREAM was not a valid test;

The test you requested is unknown to this netperf.
Please verify that you have the correct test name, 
and that test family has been compiled into this netperf.

Expected Results:  
cd ~/src
cp /usr/portage/distfiles/netperf-2.5.0.tar.bz2 .
bunzip2 netperf-2.5.0.tar.bz2
tar xvf netperf-2.5.0.tar
cd netperf-2.5.0
./configure --enable-sctp
make
cd src
sudo ./netserver -p 9000
./netperf -p 9000 -H 127.0.0.1 -t SCTP_STREAM
SCTP STREAM TEST from 0.0.0.0 (0.0.0.0) port 0 AF_INET to 127.0.0.1 (127.0.0.1) port 0 AF_INET
Recv   Send    Send                          
Socket Socket  Message  Elapsed              
Size   Size    Size     Time     Throughput  
bytes  bytes   bytes    secs.    10^6bits/sec  

212992 212992 212992    10.20       1.67   

My suggestion is to not only add "sctp" USE flag to "netperf"s EBUILD, but to
make it a general USE flag in;

/usr/portage/profiles/use.desc

That way it's available for any program.
Comment 1 K. Sanborn 2012-09-27 10:10:47 UTC
Changing Importance from "normal" to "low".
Comment 2 Jeroen Roovers (RETIRED) gentoo-dev 2012-09-27 15:11:11 UTC
There are numerous features that are disabled by default that we don't provide USE flags for.
Comment 3 Jeroen Roovers (RETIRED) gentoo-dev 2012-09-27 15:32:53 UTC
Actually, adding support for most of them exhibits more and more evidence of a rather quirky autotools setup, so I'll make life easier and just include SCTP support for now.

I might add that this does require a recent enough kernel/linux-headers/glibc to work, or it will be quietly disabled anyway in configure.
Comment 4 Jeroen Roovers (RETIRED) gentoo-dev 2012-09-27 15:36:17 UTC
*netperf-2.6.0-r1 (27 Sep 2012)

  27 Sep 2012; Jeroen Roovers <jer@gentoo.org> +netperf-2.6.0-r1.ebuild,
  metadata.xml:
  Add support for SCTP performance tests by K. Sanborn (bug #436398).


Thanks for reporting. Please file a new bug report if you need any more features that we currently do not enable.
Comment 5 K. Sanborn 2012-09-29 09:08:35 UTC
Thanks for adding that USE flag. I've tested it and all works, (with SCTP Kernel
support of course).  I suspect within 5 years SCTP will be more valuable with
it's enhanced optional features, (multi-homing and out of order packet reception).

> emerge -vp netperf

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   ~] net-analyzer/netperf-2.6.0-r1  USE="sctp -demo" 0 kB

Total: 1 package (1 reinstall), Size of downloads: 0 kB
> sudo netserver -p 9000
Starting netserver with host 'IN(6)ADDR_ANY' port '9000' and family AF_UNSPEC
> netperf -p 9000 -H 127.0.0.1 -t SCTP_STREAM_MANY
SCTP 1-TO-MANY STREAM TEST from 0.0.0.0 (0.0.0.0) port 0 AF_INET to 127.0.0.1 () port 0 AF_INET
Recv   Send    Send
Socket Socket  Message  Elapsed
Size   Size    Size     Time     Throughput
bytes  bytes   bytes    secs.    10^6bits/sec

212992 212992   4096    10.00     273.18